// Nancy Montanez
// Main network file
// Created: Sometime in October
// Modified: Nov. 26, 2000

#define _WIN32_WINNT 0x0400
#define WINVER 0x0400

#include <windows.h>
#include <ws2tcpip.h>

#include "dmz_net.h"
#include "dmz_net_internal.h"

//SOCKET s[MAX_CONNECT];				/* array of sockets */
//struct sockaddr_in sa[MAX_CONNECT];	/* array of socket addresses */
int init_done = 0;
CRITICAL_SECTION cs;
DMZ_SOCKET sockets[MAX_CONNECT];

BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
    switch (ul_reason_for_call)
	{
		case DLL_PROCESS_ATTACH:
		case DLL_THREAD_ATTACH:
		case DLL_THREAD_DETACH:
		case DLL_PROCESS_DETACH:
			break;
    }
    return TRUE;
}

//---------------------------------------------------
//Function: dmz_net_init
//
int dmz_net_init(void)
{
	
	WSADATA wsadata;
	int i;

	if (init_done) return DMZ_NET_INIT_ALREADY_DONE;

	for (i = 0; i < MAX_CONNECT; i++)
		sockets[i].s = INVALID_SOCKET;

	if (WSAStartup(MAKEWORD(2,2), &wsadata) != 0)
		return DMZ_NET_INIT_FAILED;
	
	// Initialize the critical section
	InitializeCriticalSection(&cs);
	init_done = 1;
	
	return (DMZ_NET_SUCCESS);
}

//---------------------------------------------------
//Function: dmz_net_kill
//
void dmz_net_kill(void)
{

	int i;

	for(i = 0; i < MAX_CONNECT; i++)
	{
		if(sockets[i].s != INVALID_SOCKET)
		{
			closesocket(sockets[i].s);
			
			
		}
		else
			continue;

	}

	// Delete the critical section
	DeleteCriticalSection(&cs);
	
	WSACleanup();
}
