/*	File:	dmzgraph_internal.h
	Author:	Alex Fedosov
	Date:	February 27, 2001
	Description:	alternative graphics library internal header
*/

#define MAX_IMAGES 512

int get_available_image(void);
int GetPixelFormat(void);
void clear_surface(LPDIRECTDRAWSURFACE surf, DWORD clr, int width, int height);
inline void __img24_srf16(unsigned char* bitmap, BYTE *surf, 
						int width, int height, LONG lPitch);
inline void __img24_srf24(unsigned char* bitmap, BYTE *surf, 
						int width, int height, LONG lPitch);
inline void __img24_srf32(unsigned char* bitmap, BYTE *surf, 
						  int width, int height, LONG lPitch);
inline void __blit16(BYTE *lpbSrc, BYTE *lpbDest, int src_w, int src_h,
					  LONG srcPitch, LONG dstPitch, int transparent);
inline void __blit24(BYTE *lpbSrc, BYTE *lpbDest, int src_w, int src_h,
					  LONG srcPitch, LONG dstPitch, int transparent);
inline void __blit32(BYTE *lpbSrc, BYTE *lpbDest, int src_w, int src_h,
					  LONG srcPitch, LONG dstPitch, int transparent);

extern LPDIRECTDRAW ddraw;
extern LPDIRECTDRAWSURFACE primary;
extern LPDIRECTDRAWSURFACE backsurf;
extern LPDIRECTDRAWSURFACE images[MAX_IMAGES];

extern int init_done;
extern int display_depth;
extern int screen_width;
extern int screen_height;
extern int last_error;

extern int numRedBits, numGrnBits, numBluBits;
extern int loRedBit, loGrnBit, loBluBit;

#pragma pack(2)		/* adjust structure padding! */

/* bitmap file header */
typedef struct dmz_bitmap_file_header
{
    unsigned short		bfType; 
    unsigned int		bfSize; 
    unsigned short		bfReserved1; 
    unsigned short		bfReserved2; 
    unsigned int		bfOffBits; 
} BITMAP_FILE_HEADER; 

#pragma pack()

/* bitmap info header */
typedef struct dmz_bitmap_info_header
{
    unsigned int	biSize; 
    long			biWidth; 
    long			biHeight; 
    unsigned short	biPlanes; 
    unsigned short	biBitCount;
    unsigned int	biCompression; 
    unsigned int	biSizeImage; 
    long			biXPelsPerMeter; 
    long			biYPelsPerMeter; 
    unsigned int	biClrUsed; 
    unsigned int	biClrImportant; 
} BITMAP_INFO_HEADER; 

