/*	File:	internal.cpp
	Author:	Alex Fedosov
	Date:	March 14, 2001
	Description:	internal functions for new graphics library
*/

#include <windows.h>
#include <ddraw.h>

#include <stdio.h>

#include "dmzgraph.h"
#include "dmzgraph_internal.h"

int dmz_graph_get_last_error(void)
{
	return last_error;
}

int get_available_image(void)
{
	int i;

	for (i = 1; i < MAX_IMAGES; i++)
		if (images[i] == NULL)
			return i;

	return -1;
}

void clear_surface(LPDIRECTDRAWSURFACE surf, DWORD clr, int width, int height)
{
	RECT rect;
	DDBLTFX bltfx;

	ZeroMemory(&bltfx, sizeof(bltfx));
	bltfx.dwSize = sizeof(bltfx);
	bltfx.dwFillColor = clr;

	rect.left = 0;
	rect.top = 0;
	rect.right = width;
	rect.bottom	= height;

	surf->Blt(&rect, 0, 0, DDBLT_COLORFILL | DDBLT_WAIT, &bltfx);
}
