//Nancy Montanez1
/* test of the dmz network library */

#include <windows.h>
#include <commctrl.h>
#include <cstring>
#include <cstdio>
#include <cctype>

#define PORT 3210

#include "resource.h"
#include "dmz_net.h"

LRESULT CALLBACK WindowFunc(HWND, UINT, WPARAM, LPARAM);
BOOL CALLBACK DialogFuncIP(HWND, UINT, WPARAM, LPARAM);
BOOL CALLBACK DialogFuncCHAT(HWND, UINT, WPARAM, LPARAM);

char szWinName[] = "dmznettest";
char ipaddr[32] = "0.0.0.0";
int	 listen_id, connect_id;

HINSTANCE hInst;

int WINAPI WinMain(HINSTANCE hThisInst, HINSTANCE hPrevInst,
				   LPSTR lpszArgs, int nWinMode)
{
	HWND hwnd;
	MSG msg;
	WNDCLASSEX wcl;
	INITCOMMONCONTROLSEX cc;
	
	/* define a window class */
	wcl.cbSize = sizeof(WNDCLASSEX);

	wcl.hInstance = hThisInst;
	wcl.lpszClassName = szWinName;
	wcl.lpfnWndProc = WindowFunc;
	wcl.style = 0;

	wcl.hIcon = LoadIcon(NULL, IDI_APPLICATION);
	wcl.hIconSm = LoadIcon(NULL, IDI_WINLOGO);
	wcl.hCursor = LoadCursor(NULL, IDC_ARROW);

	wcl.lpszMenuName = "MENU_NETTEST";
	wcl.cbClsExtra = 0;
	wcl.cbWndExtra = 0;

	wcl.hbrBackground = (HBRUSH) GetStockObject(WHITE_BRUSH);

	/* register the window class */
	if (!RegisterClassEx(&wcl)) return 0;

	hInst = hThisInst;

	/* window class registered, now create it */
	hwnd = CreateWindow(
		szWinName,
		"dmz network test",
		WS_OVERLAPPEDWINDOW,
		CW_USEDEFAULT,
		CW_USEDEFAULT,
		CW_USEDEFAULT,
		CW_USEDEFAULT,
		HWND_DESKTOP,
		NULL,
		hThisInst,
		NULL
	);

	// initialize the common controls
	cc.dwSize = sizeof(INITCOMMONCONTROLSEX);
	cc.dwICC = ICC_BAR_CLASSES | ICC_INTERNET_CLASSES;
	InitCommonControlsEx(&cc);

	/* display the window */
	ShowWindow(hwnd, nWinMode);

	UpdateWindow(hwnd);

	/* create the message loop */
	while (GetMessage(&msg, NULL, 0, 0))
	{
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}

	return msg.wParam;
}

LRESULT CALLBACK WindowFunc(HWND hwnd, UINT message,
							WPARAM wparam, LPARAM lparam)
{
	switch (message)
	{
	case WM_CREATE:
		dmz_net_init();
		break;

	case WM_COMMAND:
		switch (LOWORD(wparam))
		{
		case ID_FILE_CONNECT:
			DialogBox(hInst, "IPADDR", hwnd, (DLGPROC) DialogFuncIP);
			MessageBox(hwnd, ipaddr, "Connecting to...", MB_OK);
			connect_id = dmz_connect(ipaddr, PORT);
			
			if (connect_id < 0)
			{
				char s[80];
				sprintf(s, "dmz_connect returned %d", connect_id);
				MessageBox(hwnd, s, "Error", MB_OK);
			}
			
			else
				DialogBox(hInst, "CHAT", hwnd, (DLGPROC) DialogFuncCHAT);

			break;
		
		case ID_FILE_LISTEN:
			listen_id = dmz_listen(PORT, 16);
			connect_id = dmz_accept(listen_id);

			if (connect_id < 0)
			{
				char s[80];
				sprintf(s, "dmz_accept returned %d", connect_id);
				MessageBox(hwnd, s, "Error", MB_OK);
			}

			else
				DialogBox(hInst, "CHAT", hwnd, (DLGPROC) DialogFuncCHAT);

			break;

		case ID_HELP_ABOUT:
			MessageBox(hwnd, "dmz_net test\nTeam Overclocked 2000", "About", MB_OK);
			break;
		
		case ID_FILE_EXIT:
			DestroyWindow(hwnd);
			break;

		default:
			break;
		}
		break;
	
	case WM_DESTROY:
		PostQuitMessage(0);
		break;
		
	default:
		return DefWindowProc(hwnd, message, wparam, lparam);
	}

	return 0;
}

BOOL CALLBACK DialogFuncIP(HWND hdwnd, UINT message, WPARAM wparam, LPARAM lparam)
{
	static HWND hIP;
	DWORD IPaddr;

	switch (message)
	{
	case WM_INITDIALOG:
		hIP = CreateWindow(WC_IPADDRESS, "IP Address",
			WS_BORDER | WS_VISIBLE | WS_CHILD | WS_TABSTOP,
			20, 0, 140, 20, hdwnd, NULL, hInst, NULL);
		break;
		return 1;

	case WM_COMMAND:
		switch (LOWORD(wparam))
		{
		case IDCANCEL:
			EndDialog(hdwnd, 0);
			return 1;
		case IDOK:
			SendMessage(hIP, IPM_GETADDRESS, 0, (LPARAM) &IPaddr);
			sprintf(ipaddr, "%d.%d.%d.%d", FIRST_IPADDRESS(IPaddr),
				SECOND_IPADDRESS(IPaddr), THIRD_IPADDRESS(IPaddr),
				FOURTH_IPADDRESS(IPaddr));
				
			EndDialog(hdwnd, 0);
			return 1;
		}
	}

	return 0;
}

BOOL CALLBACK DialogFuncCHAT(HWND hdwnd, UINT message, WPARAM wparam, LPARAM lparam)
{
	static char sendbuf[128];
	static char recvbuf[128];
	int n;
	
	n = dmz_recv_msg(recvbuf, 128-1, connect_id);

	if(n > 0)
	{
		recvbuf[n] = '\0';
		SetDlgItemText(hdwnd, IDC_EDIT_RECV, recvbuf);
	}

//	else
//	{
//		char buf[80];
//		sprintf(buf, "receive returned %d\n", n);
//		MessageBox(hdwnd, buf, "Error!", MB_OK);
//	}

	switch (message)
	{
	case WM_COMMAND:
		switch (LOWORD(wparam))
		{
		case IDC_BTN_SEND:
			n = GetDlgItemText(hdwnd, IDC_EDIT_SEND, sendbuf, 128-1);
			SetDlgItemText(hdwnd, IDC_EDIT_RECV, sendbuf);
			SetDlgItemText(hdwnd, IDC_EDIT_SEND, "\0");
			
			dmz_send_msg(sendbuf, n, connect_id);
			break;

		case IDCANCEL:
			EndDialog(hdwnd, 0);
			return 1;
		}
	}

	return 0;
}
